#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <fcntl.h>
#include <pthread.h>
#include <unistd.h>
#include <termios.h>
#include <mosquitto.h>
#include <cjson/cJSON.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <ifaddrs.h>
#include "gps.h"
#include "main.h"
#include "ip.h"
#include "mqtt.h"
#include "serial.h"
#include "delay.h"
#include "opensh.h"

char buffer[15]; // 用于存储文件内容

void *serial_usart1(void *arg)
{ 
    printf("serial_usart 1 start\n");
    
    serial_Receive_1();//串口接收1，用于以后读取引脚高低电平

    return NULL; 
}

void *AppExit(void *arg)//2s程序，出现意外2s自动停止
{ 
  
    while(1)
    {    
        unsigned char bufpwm1[3]={gtypeTemp,1,0};
        unsigned char bufpwm2[3]={gtypeTemp,2,0};
        unsigned char bufpwm3[3]={gtypeTemp,3,0};
        unsigned char bufpwm4[3]={gtypeTemp,4,0};
        gPwmCount++;
        Delay_Ms(0,100);
        if(gPwmCount>4)
        {
        gPwmCount=5;
        serial_Write(bufpwm1);
        serial_Write(bufpwm2);
        serial_Write(bufpwm3);
        serial_Write(bufpwm4);
        
        } 
    }
    
    return NULL; 
}

void *Mqttbeat(void *arg)
{ 
    printf("Mqttbeat start\n");
    Delay_Ms(30,0);
    refresh_cam();
    Delay_Ms(5,0);
    refresh_cam();
    Delay_Ms(20,0);
    refresh_cam();
    Delay_Ms(10,0);
    while(1)
    {
        ipaddr();//获取ip
        Delay_Ms(3,0);
        mqtt_wirte();//心跳，3s一个
        
    }
    
    
    return NULL;
}

void *opensh(void *arg)
{ 
    Delay_Ms(10,0);
     printf("open cam\n");
    opencamsh();//10s后打开火狐游览器并且进入网址
   return NULL; 
}

void *serial_usart2(void *arg)
{ 
    
    printf("serial_usart 2 start\n");
    serial_Receive_2();//启动串口二
    return NULL;

}

void *Mqtt_onnect(void *arg)
{
    Delay_Ms(5,0);
    mqtt_init();//mqtt初始化
    mqtt_create(mosq);//创建mqtt客户端
    mqtt_wirte();//mqtt心跳首次发送
    while(1)
    {
    mqtt_create(mosq);     
    mqtt_cycle(mosq); 
    }
      
    mqtt_clean(mosq);
    return NULL;
}

char *device_inspect()
{
    FILE *file;
    int size=0; 
    while (1) {
        file = fopen(filename, "r"); // 以只读模式打开文件

        if (file == NULL) 
        {
            printf("文件 %s 打开失败，等待中...\n", filename);
        } 
        else 
        {
            // 尝试读取文件内容
            if (fgets(buffer, sizeof(buffer), file) != NULL) 
            {
                // 如果文件内容不为空
                fclose(file);
                printf("读取到文件内容: %s\n", buffer);
                return  buffer;
            } 
            else 
            {
                printf("文件为空，等待中...\n");
            }
            fclose(file);
        }

        Delay_Ms(1,0); // 等待1秒后再次检查
    }
}

int main(int argc, char *argv[]) {

    Delay_Ms(60,0);

    TOPIC=malloc(21);
    TOPIC2=malloc(21);
    TOPIC3= malloc(15);
    TOPIC3=device_inspect();
    //sprintf(TOPIC3,"%s",buffer);
    //strcpy(TOPIC3,device_inspect());
    sprintf(TOPIC2,"dev2app/%s",TOPIC3);
    sprintf(TOPIC,"app2dev/%s",TOPIC3);
    printf("1:%s,2:%s,3:%s\n",TOPIC,TOPIC2,TOPIC3);
    system("pkill firefox");
    
    //reconnect_4g();
    
    gStart=time(NULL);//开始时间戳
   
    serial_Init();//串口初始化


    ipaddr();//获取ip

    thread_start(serial_usart1,AppExit,Mqttbeat,serial_usart2,opensh,Mqtt_onnect);
    
    thread_end();

    return EXIT_SUCCESS;
}